<?php
// no direct access
defined( '_JEXEC' ) or die( 'Restricted access' );
 
jimport( 'joomla.plugin.plugin' );
 
/**
 * Example system plugin
 */
class plgSystemAntisef404 extends JPlugin {

private $sef_enabled;
private $sef_suffix;
private $vm_alias = array('component/virtuemart/');

private $vm_manufacturer;
private $vm_cats;
private $vm_prods;
private $tr = array(
	'а'=>'a','б'=>'b','в'=>'v','г'=>'g','д'=>'d',
	'е'=>'e','ё'=>'e','ж'=>'j','з'=>'z','и'=>'i',
	'й'=>'ie','к'=>'k','л'=>'l','м'=>'m','н'=>'n',
	'о'=>'o','п'=>'p','р'=>'r','с'=>'s','т'=>'t',
	'у'=>'u','ф'=>'f','х'=>'x','ц'=>'c','ч'=>'ch',
	'ш'=>'sh','щ'=>'sh','ъ'=>'','ы'=>'i','ь'=>'',
	'э'=>'e','ю'=>'yu','я'=>'ya');
private $trb = array(
	'А'=>'a','Б'=>'b','В'=>'v','Г'=>'g','Д'=>'d',
	'Е'=>'e','Ё'=>'e','Ж'=>'j','З'=>'z','И'=>'i',
	'Й'=>'ie','К'=>'k','Л'=>'l','М'=>'m','Н'=>'n',
	'О'=>'o','П'=>'p','Р'=>'r','С'=>'s','Т'=>'t',
	'У'=>'u','Ф'=>'f','Х'=>'x','Ц'=>'c','Ч'=>'ch',
	'Ш'=>'sh','Щ'=>'sh','Ъ'=>'','Ы'=>'i','Ь'=>'',
	'Э'=>'e','Ю'=>'yu','Я'=>'ya');

/**
* Constructor.
*
* @access protected
* @param object $subject The object to observe
* @param array   $config  An array that holds the plugin configuration
* @since 1.0
*/
public function __construct( &$subject, $config ) {
	parent::__construct( $subject, $config );
 
	$jconfig = new JConfig;
	$this->sef_enabled = (bool)$jconfig->sef;
	$this->sef_suffix = (bool)$jconfig->sef_suffix ? '.html' : '';




	$database = &JFactory::getDBO();
	$query = 'SELECT `alias` FROM `#__menu` WHERE `link` LIKE "%com_virtuemart" AND `published` = 1 LIMIT 1';
	$database->setQuery($query);
	if ($alias = $database->loadResult()) $this->vm_alias[] = $alias.$this->sef_suffix;
}
 
/**
* Do something onAfterInitialise
*/
function onAfterInitialise() {
	if (!$this->sef_enabled) return;
	$current = JURI::current();
	if (preg_match('/administrator/', $current)) return;
	$base = JURI::root();
	$current = str_replace($base, '', $current);
	if (!$current || $current == 'index.php') return;
	$segments = explode('/', $current);
	if ($segments[0] == 'component') return;
	if ($this->is_alias($segments[0])) return;

	$last = count($segments) - 1;
	if ($segments[0] == 'manufacturer') {
		JRequest::setVar('option', 'com_virtuemart');
		JRequest::setVar('page', 'shop.browse');
		$mf_alias = str_replace('.html', '', $segments[$last]);
		if ($mf_id = $this->get_mf_id($mf_alias)) JRequest::setVar('manufacturer_id', $mf_id);
		return;
	}
	if (preg_match('/^view\-all\-products/', $segments[$last])) { //Это категория вирта
		JRequest::setVar('option', 'com_virtuemart');
		JRequest::setVar('page', 'shop.browse');
		$cat_alias = $segments[0];
		for ($i = 1; $i < $last; $i++) {
			$cat_alias .= '/'.$segments[$i];
		}
		if ($cat_id = $this->get_cat_id($cat_alias)) JRequest::setVar('category_id', $cat_id);
		return;
	}
	$prod_alias = str_replace('.html', '', $segments[$last]);
	if ($prod_id = $this->get_prod_id($prod_alias)) {
		JRequest::setVar('option', 'com_virtuemart');
		JRequest::setVar('page', 'shop.product_details');
		JRequest::setVar('product_id', $prod_id);
		$cat_alias = $segments[$last - 1];
		if ($cat_id = $this->get_cat_id($cat_alias)) JRequest::setVar('category_id', $cat_id);
	}
}
 
/**
* Do something onAfterRoute
*/
function onAfterRoute()
{
}
 
/**
* Do something onAfterDispatch
*/
function onAfterDispatch()
{
}
 
/**
* Do something onAfterRender
*/
function onAfterRender() {
	if (!$this->sef_enabled) return;
	$current = JURI::current();
	if (preg_match('/administrator/', $current)) return;
	$buffer = JResponse::getBody();


foreach ($this->vm_alias as $sys_alias) {
	$regexp = '/href\=(\'|")?([^\'"\s]*)'.str_replace(array('/', '.'), array('\/', '\.'), $sys_alias).'\?([^\'"\s]+)?/';
	$virtuemart_links = preg_match_all($regexp, $buffer, $matches);
	if (count($matches[3])) foreach ($matches[3] as $key => $link) {
		$linkr = str_replace('&amp;', '&', $link);
		$segments = explode('&', $linkr);
		$string_arr = array();
		if (count($segments)) foreach ($segments as $segment) {
			$variable = explode('=', $segment);
			$string_arr[$variable[0]] = $variable[1];
		}
		if (count($string_arr)) {
			if ($string_arr['page'] == 'shop.product_details') {
				if ($alias = $this->get_cat_alias($string_arr['category_id'])) {
					$alias .= '/';
				}
				$alias .= $this->get_prod_alias($string_arr['product_id']);
				$new_link = $matches[2][$key].$alias.$this->sef_suffix;
				$buffer = str_replace($matches[1][$key].$matches[2][$key].$sys_alias.'?'.$link.$matches[1][$key], $new_link, $buffer);
			}
			if ($string_arr['page'] == 'shop.browse' && !isset($string_arr['manufacturer_id'])) {
				if ($alias = $this->get_cat_alias($string_arr['category_id'])) {
					$new_link = $matches[2][$key].$alias.'/view-all-products'.$this->sef_suffix;
					preg_match('/limit=(\d+)/', $link, $lim);
					preg_match('/limitstart=(\d+)/', $link, $limst);
					if ($lim[1] && $limst[1]) {
						$new_link .= '?limit='.$lim[1].'&limitstart='.$limst[1];
					} elseif ($lim[1]) {
						$new_link .= '?limit='.$lim[1];
					} elseif ($limst[1]) {
						$new_link .= '?limitstart='.$limst[1];
					}
					$buffer = str_replace($matches[1][$key].$matches[2][$key].$sys_alias.'?'.$link.$matches[1][$key], $new_link, $buffer);
				}
			}
			if ($string_arr['page'] == 'shop.browse' && isset($string_arr['manufacturer_id'])) {
				if ($alias = $this->get_mf_alias($string_arr['manufacturer_id'])) {
					$new_link = $matches[2][$key].'manufacturer/'.$alias.$this->sef_suffix;
					preg_match('/limit=(\d+)/', $link, $lim);
					preg_match('/limitstart=(\d+)/', $link, $limst);
					if ($lim[1] && $limst[1]) {
						$new_link .= '?limit='.$lim[1].'&limitstart='.$limst[1];
					} elseif ($lim[1]) {
						$new_link .= '?limit='.$lim[1];
					} elseif ($limst[1]) {
						$new_link .= '?limitstart='.$limst[1];
					}
					$buffer = str_replace($matches[1][$key].$matches[2][$key].$sys_alias.'?'.$link.$matches[1][$key], $new_link, $buffer);
				}
			}
		}
	}
}


	JResponse::setBody($buffer);
}

private function is_alias($alias) {
	$database = &JFactory::getDBO();
	$query = 'SELECT `id` FROM `#__menu` WHERE `alias` LIKE "'.$alias.'" LIMIT 1';
	$database->setQuery($query);
	return $database->loadResult();
}

private function get_cat_alias($id) {
	jimport('joomla.filesystem.folder');
	jimport('joomla.filesystem.file');
	$file_path = dirname(__FILE__).DS.'aliases'.DS.'category.alias';

	if (!JFile::exists($file_path)) {
		$database = &JFactory::getDBO();
		$query = 'SELECT `category_id`,`category_name` FROM `#__vm_category`';
		$database->setQuery($query);
		if ($results = $database->loadObjectList()) {
			$this->vm_cats = array();
			if (count($results)) foreach ($results as $result) {
				$target_cat_id = $result->category_id;
				$category_name = $this->transliterate($result->category_name);
				do {
					$query = 'SELECT `category_parent_id`,`category_name` FROM `#__vm_category_xref`,`#__vm_category` WHERE `category_child_id` = '.$target_cat_id.' AND `category_id` = `category_parent_id` LIMIT 1';
					$database->setQuery($query);
					$tmp = $database->loadObject();
					$target_cat_id = $tmp->category_parent_id;
					if ($target_cat_id) {
						$category_name = $this->transliterate($tmp->category_name).'/'.$category_name;
					}
				} while ($target_cat_id);

				$this->vm_cats[$result->category_id] = $category_name;
			}
			if (is_array($this->vm_cats)) {
				if (!JFolder::exists(dirname(__FILE__).DS.'aliases')) JFolder::create(dirname(__FILE__).DS.'aliases');
				$data = serialize($this->vm_cats);
				JFile::write($file_path, $data);
			}
		}
	}
	if (!is_array($this->vm_cats)) {
		$data = JFile::read($file_path);
		$this->vm_cats = unserialize($data);
	}
	if (!$this->vm_cats[$id]) {
		$database = &JFactory::getDBO();
		$query = 'SELECT `category_name` FROM `#__vm_category` WHERE `category_id` = '.$id;
		$database->setQuery($query);
		if ($alias = $database->loadResult()) {
			$this->vm_cats[$id] = $this->transliterate($alias);
			if (!JFolder::exists(dirname(__FILE__).DS.'aliases')) JFolder::create(dirname(__FILE__).DS.'aliases');
			$data = serialize($this->vm_cats);
			JFile::write($file_path, $data);
		}
	}
	return $this->vm_cats[$id];
}

private function get_cat_id($alias) {
	if (!is_array($this->vm_cats)) {
		jimport('joomla.filesystem.folder');
		jimport('joomla.filesystem.file');
		$file_path = dirname(__FILE__).DS.'aliases'.DS.'category.alias';
		$data = JFile::read($file_path);
		$this->vm_cats = unserialize($data);
	}
	return (int) array_search($alias, $this->vm_cats);
}

private function get_prod_alias($id) {
	jimport('joomla.filesystem.folder');
	jimport('joomla.filesystem.file');
	$file_path = dirname(__FILE__).DS.'aliases'.DS.'product.alias';

	if (!JFile::exists($file_path)) {
		$database = &JFactory::getDBO();
		$query = 'SELECT `product_id`,`product_name` FROM `#__vm_product`';
		$database->setQuery($query);
		if ($results = $database->loadObjectList()) {
			$this->vm_prods = array();
			if (count($results)) foreach ($results as $result) {
				$product_name = $this->transliterate($result->product_name);
				$this->vm_prods[$result->product_id] = $product_name;
			}
			if (is_array($this->vm_prods)) {
				if (!JFolder::exists(dirname(__FILE__).DS.'aliases')) JFolder::create(dirname(__FILE__).DS.'aliases');
				$data = serialize($this->vm_prods);
				JFile::write($file_path, $data);
			}
		}
	}
	if (!is_array($this->vm_prods)) {
		$data = JFile::read($file_path);
		$this->vm_prods = unserialize($data);
	}
	if (!$this->vm_prods[$id]) {
		$database = &JFactory::getDBO();
		$query = 'SELECT `product_name` FROM `#__vm_product` WHERE `product_id` = '.$id;
		$database->setQuery($query);
		if ($alias = $database->loadResult()) {
			$this->vm_prods[$id] = $this->transliterate($alias);
			if (!JFolder::exists(dirname(__FILE__).DS.'aliases')) JFolder::create(dirname(__FILE__).DS.'aliases');
			$data = serialize($this->vm_prods);
			JFile::write($file_path, $data);
		}
	}
	return $this->vm_prods[$id];
}

private function get_prod_id($alias) {
	if (!is_array($this->vm_prods)) {
		jimport('joomla.filesystem.folder');
		jimport('joomla.filesystem.file');
		$file_path = dirname(__FILE__).DS.'aliases'.DS.'product.alias';
		$data = JFile::read($file_path);
		$this->vm_prods = unserialize($data);
	}
	return (int) array_search($alias, $this->vm_prods);
}

private function get_mf_alias($id) {
	jimport('joomla.filesystem.folder');
	jimport('joomla.filesystem.file');
	$file_path = dirname(__FILE__).DS.'aliases'.DS.'manufacturer.alias';

	if (!JFile::exists($file_path)) {
		$database = &JFactory::getDBO();
		$query = 'SELECT `manufacturer_id`,`mf_name` FROM `#__vm_manufacturer`';
		$database->setQuery($query);
		if ($results = $database->loadObjectList()) {
			$this->vm_manufacturer = array();
			if (count($results)) foreach ($results as $result) {
				$mf_name = $this->transliterate($result->mf_name);
				$this->vm_manufacturer[$result->manufacturer_id] = $mf_name;
			}
			if (is_array($this->vm_manufacturer)) {
				if (!JFolder::exists(dirname(__FILE__).DS.'aliases')) JFolder::create(dirname(__FILE__).DS.'aliases');
				$data = serialize($this->vm_manufacturer);
				JFile::write($file_path, $data);
			}
		}
	}
	if (!is_array($this->vm_manufacturer)) {
		$data = JFile::read($file_path);
		$this->vm_manufacturer = unserialize($data);
	}
	if (!$this->vm_manufacturer[$id]) {
		$database = &JFactory::getDBO();
		$query = 'SELECT `mf_name` FROM `#__vm_manufacturer` WHERE `manufacturer_id` = '.$id;
		$database->setQuery($query);
		if ($alias = $database->loadResult()) {
			$this->vm_manufacturer[$id] = $this->transliterate($alias);
			if (!JFolder::exists(dirname(__FILE__).DS.'aliases')) JFolder::create(dirname(__FILE__).DS.'aliases');
			$data = serialize($this->vm_manufacturer);
			JFile::write($file_path, $data);
		}
	}
	return $this->vm_manufacturer[$id];
}

private function get_mf_id($alias) {
	if (!is_array($this->vm_manufacturer)) {
		jimport('joomla.filesystem.folder');
		jimport('joomla.filesystem.file');
		$file_path = dirname(__FILE__).DS.'aliases'.DS.'manufacturer.alias';
		$data = JFile::read($file_path);
		$this->vm_manufacturer = unserialize($data);
	}
	return (int) array_search($alias, $this->vm_manufacturer);
}

private function transliterate($value) {
	$value = trim($value);
	$value = strtr($value, $this->trb);
	$value = strtr($value, $this->tr);
	$value = preg_replace('/\s+/', '-', $value);
	$value = preg_replace('/[^\w\d\-]/', '', $value);
	return strtolower($value);
}
}